//+------------------------------------------------------------------+
//|                                        AndrewsPitchforkAlert.mq4 |
//+------------------------------------------------------------------+
#property copyright "K"

#property indicator_chart_window
extern string TLineName="PitchforkAlert"; //  
extern color LineColor=Blue;  //  
extern int LineStyle=STYLE_SOLID; //  
extern int LineWidth=1; //   
extern int AlertPipRange=2; //   
extern string AlertWav1="falling-price-alert.wav"; //     1
extern string AlertWav2="falling-price-alert.wav"; //     2
extern string AlertWav3="falling-price-alert.wav"; //     3
extern int t_interval=60; //    (.)
int t_old, t_cur;
double p1, p2, p3, k0, t1, t2, t3, range;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
if(ObjectFind(TLineName)!=0 || ObjectType(TLineName)!=OBJ_PITCHFORK) 
{
Comment(" !" + "\n" + "         " + TLineName);
return(0);
}
Comment("");
t1=ObjectGet(TLineName, OBJPROP_TIME1); 
t2=ObjectGet(TLineName, OBJPROP_TIME2); 
t3=ObjectGet(TLineName, OBJPROP_TIME3);
p1=ObjectGet(TLineName, OBJPROP_PRICE1);
p2=ObjectGet(TLineName, OBJPROP_PRICE2);
p3=ObjectGet(TLineName, OBJPROP_PRICE3);
k0=((p3+p2)/2-p1)/((t3+t2)/2-t1);
t_cur=TimeCurrent();
range=AlertPipRange*Point;
      if (line_dist(t1, p1, k0)<=range && t_cur>t_old+t_interval)
      {
      t_old=t_cur;
      PlaySound(AlertWav1);
      }
      if (line_dist(t2, p2, k0)<=range && t_cur>t_old+t_interval)
      {
      t_old=t_cur;
      PlaySound(AlertWav2);
      }
      if (line_dist(t3, p3, k0)<=range && t_cur>t_old+t_interval)
      {
      t_old=t_cur;
      PlaySound(AlertWav3);
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
double line_dist(double t, double p, double k)
{
   double b=p-k*t;
   double dist=MathAbs(Bid-k*Time[0]-b);
   return(dist);
}

